clear all; 
close all; 
addpath wild_Cropped
addpath('functions/cbrewer')
load AnalysisWildF; 
% -- SETUP COLORMAP 
RdYlBu= flipud(cbrewer('div', 'RdYlBu', 256));
OrRd = cbrewer('seq', 'OrRd', 256);
Reds = cbrewer('seq', 'Reds', 256);
RdBu= flipud(cbrewer('div', 'RdBu', 256));
cMap =  jet(8);%['b','c','m','r'];
NMouse = 5;
 
%% low-spatial frequency
for iM = 2:NMouse
     saveFname = ['wild_Cropped/wildM', num2str(iM), 'UVFL'];
     load(saveFname);
    for iW = 2:8
        for iS = 1:2
            F = []; F = (F_coarse{iM}{iS, iW});
            meanF(iM, iW, iS) = mean(reshape((F), 1,[]));
            stdF(iM, iW, iS) = std(reshape((F), 1,[]));  
            Fx{iS}(iM, iW, :) = mean(F, 1); 
            Fy{iM, iS}(:, iW) = mean(F, 2);
%             F(abs(F) > 10) = 10;               
%             Fx{iM, iS}(iW, :) = sum(abs(F),1); 
%             Fy{iM, iS}(:, iW) = sum(abs(F), 2);
        end
    end
end
Xper = reshape(mean(Fx{1}(:, 2:end,:)), 7,360); % over angle
Xpstd = reshape(std(Fx{1}(:, 2:end,:)), 7,360); % over angle
Xend = reshape(mean(Fx{2}(:, 2:end,:)), 7,360);
Xestd = reshape(std(Fx{2}(:, 2:end,:)), 7,360); % over angle

for iM = 2:NMouse
    % -- for X direction
    for iS = 1:2
        switch iS 
            case 1
            YL = []; YL = [1:size(Fy{iM, iS}(:, 1))]./size(Fy{iM, iS}(:, 1), 1).*100;
            YperTp = []; YperTp = Fy{iM, iS}(:, 2:end);
            YP(iM,:,:) = interp1(YL, YperTp, 0.1:0.1:100);
            case 2
            YL = []; YL = [1:size(Fy{iM, iS}(:, 1))]./size(Fy{iM, iS}(:, 1), 1).*100;
            YendTp = []; YendTp = Fy{iM, iS}(:, 2:end);
            YE(iM,:,:) = interp1(YL, YendTp, 0.1:0.1:100);
        end
    end
end

Yper = reshape(mean(YP,1), 1000, 7); % over angle
Ypstd = reshape(std(YP), 1000, 7); % over angle
Yend = reshape(mean(YE), 1000,7);
Yestd = reshape(std(YE), 1000, 7); % over angle
clear YP YE 

% ======== Over angle
figure(1);
set(gcf, 'color',[1,1,1]);
set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.4, 0.3])       
hold on; 
xlim([-180, 180]); 
ax = gca, ax.XTick = [-180:45:180];
set(ax, 'fontSize', 14)
xlabel('Degree (\circ)');
zlabel('Average geometry change (\mum)');
ylabel('Weeks');
title({'Average change over angles (Periosteum)'});
grid on;  
     
figure(2);
set(gcf, 'color',[1,1,1]);
set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.4, 0.3])       
hold on; 
xlim([-180, 180]); 
ax = gca, ax.XTick = [-180:45:180];
set(ax, 'fontSize', 14)
xlabel('Degree (\circ)');
zlabel('Average geometry change (\mum)');
ylabel('Weeks');
title({'Average change over angles (endosteum)'});
grid on; 

WEEK = [16:22];
figure(1)
imagesc(UVFinfo(1,1).xlimits,WEEK,Xper);
colormap(RdBu);
caxis([0,40]);
colorbar; 
drawnow;
figName = ['wild_Cropped/WildM_ChangeOverX_per_low'];
%     print(figName, '-dpng', '-r300');
                         
figure(2)
imagesc(UVFinfo(1,1).xlimits, WEEK,  Xend);
colormap(RdBu)
caxis([0,40]);
colorbar;  
drawnow; 
figName = ['wild_Cropped/WildM_ChangeOverX_end_low'];
%     print(figName, '-dpng', '-r300');

% --- low-spatial frequency std
iW = 16:22;
figure(11) 
set(gcf, 'color',[1,1,1]);
set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.4, 0.3])       
hold on; 
xlim([1, 100]);
ax = gca; ax.XTick = [0:10:100];
set(ax, 'fontSize', 14)
xlabel('Bone height (%)');
zlabel('Average geometry change (\mum)');
ylabel('Weeks');
grid on; 
     
figure(21) 
set(gcf, 'color',[1,1,1]);
set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.4, 0.3])       
hold on; 
xlabel('Bone height (%)');
zlabel('Average changes (\mum)');
ylabel('Weeks'); 
xlim([1, 100]);
ax = gca; ax.XTick = [0:10:100];
set(ax, 'fontSize', 14);
%    title({'Average change over Z-direction', ['WildM', num2str(iM), 'End']});
grid on;  
     
figure(11)
xStart = UVFinfo(1, 1).zlimits(1);
xEnd = UVFinfo(1, 1).zlimits(1) +  size(Fy{iM, iS}(:, 2)) - 1;
imagesc([1:100], iW, Yper');
colormap(RdBu);
caxis([0,40]);
%    caxis([0, 30])
colorbar; 
figName = ['wild_Cropped/WildM_ChangeOverZ_per_low'];
%      print(figName, '-dpng', '-r300');

figure(21)
xStart = UVFinfo(2, 1).zlimits(1);
xEnd = UVFinfo(2, 1).zlimits(1) +  size(Fy{iM, iS}(:, 2)) - 1;
imagesc(1:100,  iW, Yend');
colormap(RdBu)
caxis([0, 40])
colorbar; 
figName = ['wild_Cropped/WildM_ChangeOverZ_end_low'];
%      print(figName, '-dpng', '-r300');


% ======= Bone high-spatial frequency
for iM = 2:NMouse
     saveFname = ['wild_Cropped/wildM', num2str(iM), 'UVFL'];
     load(saveFname);
    for iW = 2:8
        for iS = 1:2
            F = []; F = abs(F_fine{iM}{iS, iW});
            meanF(iM, iW, iS) = mean(reshape((F), 1,[]));
            stdF(iM, iW, iS) = std(reshape((F), 1,[]));  
           Fx{iS}(iM, iW, :) = mean(F, 1); 
           Fy{iM, iS}(:, iW) = mean(F, 2);
        end
    end
end
Xper = reshape(mean(Fx{1}(:, 2:end,:)), 7,360); % over angle
Xpstd = reshape(std(Fx{1}(:, 2:end,:)), 7,360); % over angle
Xend = reshape(mean(Fx{2}(:, 2:end,:)), 7,360);
Xestd = reshape(std(Fx{2}(:, 2:end,:)), 7,360); % over angle

for iM = 2:NMouse
    % -- for X direction
    for iS = 1:2
        switch iS 
            case 1
            YL = []; YL = [1:size(Fy{iM, iS}(:, 1))]./size(Fy{iM, iS}(:, 1), 1).*100;
            YperTp = []; YperTp = Fy{iM, iS}(:, 2:end);
            YP(iM,:,:) = interp1(YL, YperTp, 0.1:0.1:100);
            case 2
            YL = []; YL = [1:size(Fy{iM, iS}(:, 1))]./size(Fy{iM, iS}(:, 1), 1).*100;
            YendTp = []; YendTp = Fy{iM, iS}(:, 2:end);
            YE(iM,:,:) = interp1(YL, YendTp, 0.1:0.1:100);
        end
    end
end

Yper = reshape(mean(YP,1), 1000, 7); % over angle
Ypstd = reshape(std(YP), 1000, 7); % over angle
Yend = reshape(mean(YE), 1000,7);
Yestd = reshape(std(YE), 1000, 7); % over angle
clear YP YE 

 figure(3);
 set(gcf, 'color',[1,1,1]);
 set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.4, 0.3])       
 hold on; 
 xlim([-180, 180]); 
 ax = gca, ax.XTick = [-180:45:180];
 set(ax, 'fontSize', 14)
 xlabel('Degree (\circ)');
 zlabel('Average geometry change (\mum)');
 ylabel('Weeks');
%      title({'Average change over angles (Periosteum)'});
 grid on;  
     
 figure(4);
 set(gcf, 'color',[1,1,1]);
 set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.4, 0.3])       
 hold on; 
 xlim([-180, 180]); 
 ax = gca, ax.XTick = [-180:45:180];
 set(ax, 'fontSize', 14)
 xlabel('Degree (\circ)');
 zlabel('Average geometry change (\mum)');
 ylabel('Weeks');
%      title({'Average change over angles (endosteum)'});
 grid on; 

 WEEK = [16:22];
 figure(3)
 imagesc(UVFinfo(1,1).xlimits,WEEK,Xper);
 colormap(RdBu);
 caxis([0,10]);
 colorbar; 
 drawnow;
 figName = ['wild_Cropped/WildM_ChangeOverX_per_high'];
%  print(figName, '-dpng', '-r300');
                     

  figure(4)
  imagesc(UVFinfo(1,1).xlimits, WEEK,  Xend);
  colormap(RdBu)
  caxis([0,10]);
  colorbar;  
  drawnow; 
  figName = ['wild_Cropped/WildM_ChangeOverX_end_high'];
%   print(figName, '-dpng', '-r300');

 iW = 16:22;
    figure(31) 
    set(gcf, 'color',[1,1,1]);
    set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.4, 0.3])       
    hold on; 
    xlim([1, 100]);
    ax = gca; ax.XTick = [0:10:100];
    set(ax, 'fontSize', 14)
    xlabel('Bone height (%)');
    zlabel('Average geometry change (\mum)');
    ylabel('Weeks');
    grid on;
     
     figure(41) 
     set(gcf, 'color',[1,1,1]);
     set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.4, 0.3])       
     hold on; 
     xlabel('Bone height (%)');
     zlabel('Average changes (\mum)');
     ylabel('Weeks'); 
     xlim([1, 100]);
     ax = gca; ax.XTick = [0:10:100];
     set(ax, 'fontSize', 14);
%      title({'Average change over Z-direction', ['WildM', num2str(iM), 'End']});
     grid on;  
         
figure(31)
imagesc([1:100], iW, Yper');
colormap(RdBu)
caxis([0, 30])
colorbar; 
figName = ['wild_Cropped/WildM_ChangeOverZ_per_high'];
% print(figName, '-dpng', '-r300');

figure(41)
imagesc(1:100,  iW, Yend');
colormap(RdBu)
caxis([0, 30])
colorbar; 
figName = ['wild_Cropped/WildM_ChangeOverZ_end_high'];
% print(figName, '-dpng', '-r300');
