% 2D map theta-z and corresponding F
% iStep = 1 generates the 'wildM1UVF.m' 
% iStep = 2 plot the results of decomposition and denoise of the UVF map. 
clear all; 
close all;
cla; 

% dataType = 'wildPTH'; % 'wildPTH'
dataType = 'wild';
cropped = '_Cropped'; % '';
iStep = 2;
figSign = 1;
addpath('functions');
addpath([dataType, cropped]);

if iStep == 1
WEEKS = [2];%[2:8]
iMice = 5; 
faceName = {'Periosteum', 'Endosteum'};
for iW = WEEKS
    tic
    display(num2str(iW));
    Weeks = [0, iW];
    loadFileName = [dataType, 'M', num2str(iMice),'F_wk0', num2str(iW)];    
    saveFileName = [dataType, 'M', num2str(iMice),'W0', num2str(iW)];
    load(loadFileName);
    cMap = [];       
          
    for iS = 1:2
        if iS == 1  %Periosteum                
            Idx1 = []; Idx1 = round(s_per(1).vertices); 
            Idx2 = []; Idx2 = round(s_per(2).vertices);                
            cMap = cMap_per;
        else      % Endosteum
                
            Idx1 = []; Idx1 = round(s_end(1).vertices); 
            Idx2 = []; Idx2 = round(s_end(2).vertices);
            cMap = cMap_end;
        end
        
        z1min = min(Idx1(:,3)); z2min = min(Idx2(:,3));
        z1max = max(Idx1(:,3)); z2max = max(Idx2(:,3));
        Z1 = [z1min:1:z1max];
        Z2 = [z2min:1:z2max];
 %       Week 0 is the standard time            
        c1 = zeros(z1max - z1min + 1, 3);                
        UVF=[]; 
        L = [];
       for z = Z1
           V = []; 
           V = Idx1((Idx1(:,3) >= z & Idx1(:,3) < z+1),:); % wk0
           szC(z,:) = length(V);
           c1(z,:) = median(V, 1); % center 1
           V1 = V - repmat(c1(z,:), size(V, 1), 1); %VECTOR
           L = [L; sqrt(V1(:, 1).^2 + V1(:,2).^2)];
           angleVC = [];
           for i = 1:size(V1, 1)    
                angleVC(i) = atan2d(V1(i,2), V1(i, 1));
           end    
           Ut = []; Ut = [angleVC' V(:,3)];
           UVF = [UVF; Ut];
%          scatter(V(:,1), V(:,2),40,angleVC','.');
       end
    % Angle - UV(:,1); Zxis - UV(:,2);  cMap
    r = 1;  [Uq, Vq] = meshgrid(-180+r:r:180, z1min : r : z1max);    
    UVF = [UVF cMap];  
    % clearvars -except UVF Uq Vq loadFile  
    
    Tp = []; [~,Tp] = sort(abs(UVF(:,3)));
    Temp = []; Temp = UVF(Tp,:);   
    C = []; [C, ia, ic] = unique(round(Temp(:,1:2)), 'rows', 'stable');
    C = [C, Temp(ia, 3)];
    Fq = griddata(double(C(:,1)), double(C(:,2)), double(C(:,3)), Uq, Vq);
 
    if mod(size(Fq,1),2) == 1
       X  = Fq(2:end,:);
    else
       X = Fq;   
    end
    UVFinfo(iS, iW - 1) = struct('Mice', [dataType,'M', num2str(iMice)], ...
        'Weeks',Weeks, 'faceName', faceName{iS}, 'UVF', UVF, ...
        'XZmap', X, 'zlimits', Z1, 'xlimits', [-179:180]);
    end
   clearvars -except iW WEEKS iMice faceName UVFinfo iStep dataType cropped
   toc
end
    saveFname = [dataType, cropped, '/', dataType, 'M', num2str(iMice), 'UVFL'];
    save(saveFname, 'iMice', 'WEEKS', 'faceName', 'UVFinfo');
end
% % % %%
% %=============================================================%
% %======                                                 ======%
% %======          case 2 ---   Analysis                  ======%
% %======        Analysis  over every week                ======%
% %======         wk0  -  wk3  -... - wk8                 ======%
% %======                                                 ======%
% %=============================================================%
% % UVF coordinates
% % UVF(:,1) -- U is angle to centre .
% % UVF(:,2) -- V is the height corresbonding to z axis  
% %          -- Equals to Idx(:,3)
% % UVF(:,3) -- F is the growth rate -F*10.4.
% %          -- cMap, growth rate (microns)
% % UVFinfo(iS, iW - 1) = ...
% % struct('Mice', ['wildM', num2str(iMice)], 'Weeks',Weeks, ...
    % % 'faceName', faceName{iS}, 'UVF', UVF, 'XZmap', X, 'zlimits', Z1, 'xlimits', [-179:180]); 
% % % % ===== PLOT =====

if iStep == 2
   WEEKS = 2;%[2:8];
   figSign = 1;
   addpath('functions/cbrewer')
   addpath([dataType, cropped]);
   RdYlBu= flipud(cbrewer('div', 'RdYlBu', 256));
   RdBu= flipud(cbrewer('div', 'RdBu', 256));
    
for iMice = 5%1:5
    saveFname = [dataType, 'M', num2str(iMice), 'UVFL'];  % -- Obtained from (iStep = 1)
    load(saveFname);
    iMice        
for iW = WEEKS
    display([' Processing week: ', num2str(iW)]);
    for iS = 1:2
       thisBone = []; thisBone = UVFinfo(iS, iW-1);
       X = []; X = thisBone.XZmap;    
       L = [];
        
        if figSign            
        figure(1); % == ORG
        clf;
        hold on;  set(gcf, 'color',[1,1,1]);
        set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.2, 0.4])
        imagesc([thisBone.xlimits], [thisBone.zlimits], X);
%       title({['Geometry Change at ', faceName{iS}], [thisBone.Mice, 'W0', num2str(iW)]},...
%                 'fontsize', 14);
        xlim([-200, 200]); ylim([0, 1800]); grid on; 
        ax = gca; 
        ax.XTick = [-180 -90  0 90  180];
        set(gca,'Ydir', 'normal');
        colormap(RdBu);
        caxis([-150,150]);
        set(0, 'DefaultAxesFontSize', 10.5);
        xlabel('Angle (\circ)','fontsize',12); ylabel('Z','fontsize',12);
        c = colorbar;  ax = gca;   
        axpos = ax.Position;  c.Position(3) = 0.6 * c.Position(3);  ax.Position = axpos;
        grid on;
        drawnow; 
        saveFig = [dataType, cropped, '/', thisBone.Mice, 'W0', num2str(iW), '_OrgL', faceName{iS}(1:3)]
%         print(saveFig, '-dpng', '-r300') 
        end
% ------ DEFINE the boundary condition
        padSize = (1792 - size(X, 1))/2; %1856 1920
        X0 = []; X0 = padarray(X, padSize); %152
        cirSize = 76;
        X0 = padarray(X0, [0,cirSize], 'circular');
        X0(isnan(X0)) = 0;
        
% ----- Dual tree complex wavelet analysis of signal X0           
        Depth = 4; % levels %ORGINAL Depth = 4 is used.....
        decompF =  dddtree2('cplxdt',X0,Depth,'FSfarras','qshift14'); 
        cfs = decompF.cfs;  
        cfs_cplx{iMice, iW, iS} = cfs;
               
% =========== Draw the filters
% figure;
% cla; 
% subplot(2,1,1)
% plot(decompF.filters.Df{1,1}(:,1),'lineWidth', 1.5)
% title('Low-pass')
% hold on
% plot(decompF.filters.Df{1,2}(:,1), 'lineWidth', 1.5')
% grid on; 
% plot(abs(decompF.filters.Df{1,1}(:,1) + decompF.filters.Df{1,2}(:,1)*j),'-.',...
%     'lineWidth', 2)
% legend('Real', 'Imaginary', 'Magnitude')
% 
% subplot(2,1,2)
% plot(decompF.filters.Df{1,1}(:,2),'lineWidth', 1.5)
% title('High-pass')
% hold on
% plot(decompF.filters.Df{1,2}(:,2), 'lineWidth', 1.5')
% grid on; 
% plot(abs(decompF.filters.Df{1,1}(:,2) + decompF.filters.Df{1,2}(:,2)*j),'-.',...
%     'lineWidth', 2)
% legend('Real', 'Imaginary', 'Magnitude')
% ===============================================


% % % % %  -- This is used to save the coefficient --------------       
% % %         switch iS
% % %             case 1
% % %             wildMD4Per_cfs{iMice, iW} = cfs; 
% % %             case 2
% % %             wildMD4End_cfs{iMice, iW} = cfs; 
% % %         end
% % %     end
% % % end
% % % end
% % % end
% % % 
% % % save wildMD4Per_cfs wildMD4Per_cfs;
% % % save wildMD4End_cfs wildMD4End_cfs
% % % % % -------------------------------------------------------
% ------ Coefficient plotting
%       yzhCplxCoefPlot(cfs, 1);                 

% --  Denoising  
    % --- Noise level estimate --- %
% % %     j = 1;
% % %     s1 = 1; % tree
% % %     s2 = 1; % Direction
% % %     i = sqrt(-1);
% % %     HH = [];HH = abs(cfs{j}(:,:, s2, s1, 1) + i * cfs{j}(:,:, s2, s1, 2));
% % %     HH (isnan(HH)) = 0;
% % %     Nsig =  median((HH(:)))/0.6745;
    
% figure; imhist(HH)
% figure; hist(HH(:),0:0.1:10)

    % ---          Universal thresholding      --- %
%         thr = Nsig * sqrt(2* log(prod(size(X0)))); % 
    %   UNIVERSAL THRESHOLD, which could work with soft threshold: 
    %       - threshodCoef = wthresh(coef, 's', thr);
    % --------------------------------------------- %
    % ---           SURE Algorithm             --- %
%        for j = 1:Depth
%         for s1 = 1:2 % Go throught the tree
%             for s2 = 1:3 % Direction
%                 C1 = []; C1 = cfs{j}(:,:, s2, s1,1) ;
%                 C2 = []; C2 = cfs{j}(:,:, s2, s1,2);
%                 C1 (isnan(C1)) = 0;
%                 C2 (isnan(C2)) = 0;
%                 C1_new = []; C1_new = SubbandThresholding(C1);
%                 C2_new = []; C2_new = SubbandThresholding(C2);
%                 cfs_new{j}(:,:, s2, s1,1)  = real(C1_new);
%                 cfs_new{j}(:,:, s2, s1,2) = imag(C2_new);
%             end
%         end
% % %        end
% % %        cfs_new{Depth + 1} = cfs{Depth + 1};         
%     ------------------------------------------------------------------ %    
    for j = 1:Depth
        for s1 = 1:2 % Go throught the tree
            for s2 = 1:3 % Direction
                C1 = []; C1 = cfs{j}(:,:, s2, s1,1) ;
                C2 = []; C2 = cfs{j}(:,:, s2, s1,2);
                C1 (isnan(C1)) = 0;
                C2 (isnan(C2)) = 0;
                i = sqrt(-1);        
                HH = [];HH = abs(cfs{j}(:,:, s2, s1, 1) + i * cfs{j}(:,:, s2, s1, 2));
                HH (isnan(HH)) = 0;
                Nsig =  median((HH(:)))/0.6745;
                C =  []; C = wthresh(C1 + i*C2, 's',Nsig);
                cfs{j}(:,:, s2, s1, 1) = real(C);
                cfs{j}(:,:, s2, s1, 2) = imag(C);
            end
        end
    end

% -- 3.5 Recovery
% --- 3. 5. 1 Coarse Scale [Figure 11, 12, 13, 14]
        dtcplx = decompF; 
        dtcplx.cfs = cfs; 
        for iD = 1:Depth
            dtcplx.cfs{iD} = zeros(size(dtcplx.cfs{iD}));
        end
        Y0 = idddtree2(dtcplx); %Inverse dual-tree and double-density 2-D wavelet transform
        Y0(1:padSize-1, :) = [];    Y0(end-padSize: end, :) = [];
        Y0(:,1:cirSize-1) = [];      Y0(:, end- cirSize:end) = [];
        X0(1:padSize-1, :) = [];    X0(end-padSize: end, :) = [];
        X0(:,1: cirSize-1) = [];      X0(:, end- cirSize:end) = [];
        F_coarse{iMice}{iS, iW} = Y0;
        
        if figSign
           figure(2); % -- The Coarse Scale Growth
           clf;
           hold on; 
           set(gcf, 'color',[1,1,1]);
           set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.2,0.4])
           imagesc([thisBone.xlimits], [thisBone.zlimits], Y0);
           xlim([-200, 200]); ylim([0, 1800]); grid on; 
           ax = gca; ax.XTick = [-180 -90 0 90 180];
           set(gca,'Ydir', 'normal');
           colormap(RdBu);
           caxis([-150,150]);
           set(0, 'DefaultAxesFontSize', 12);
           xlabel('Angle (\circ)','fontsize',12); ylabel('Z','fontsize',12);
           c = colorbar;  ax = gca;   
           axpos = ax.Position;  c.Position(3) = 0.6 * c.Position(3);  ax.Position = axpos;
           grid on;
           drawnow;
           saveFig = [dataType, cropped,'/', thisBone.Mice, 'W0', num2str(iW), '_CoarseL', faceName{iS}(1:3)]
           print(saveFig, '-dpng', '-r300')
        end
          
%     % -- HISTGRAM of Y0
          Y0(isnan(Y0)) = 0;
          Y0ave = []; Y0ave = mean(Y0, 2); Y0std = std(Y0,0, 2);
%         
         if figSign == 0
            figure(100 + iMice); 
            hold on
            set(gcf, 'Units', 'normalized', 'position', [0.05, 0.2, 0.9, 0.22])
            subplot(1, size(WEEKS, 2), iW-1)
            counts = []; centers = [];
            [counts, centers] = hist(reshape(Y0, 1, []),[-150:10:150]);
            prob = []; prob = counts./sum(counts);
            bar(centers, prob, 'BarWidth', 1);
            grid on; 
            xlim([-160,160]);
            ylim([0, 0.3]);
            set(gcf, 'color',[1,1,1]);
            title(['W0', num2str(iW)], 'fontsize', 12);
            xlabel('Geometry change (\mum)','fontsize', 12);
            ax = gca; ax.XTick = [-150:60:150]; 
            drawnow; 
%             if iW == WEEKS(end)
%             print(['wild_Cropped/HistM', num2str(iMice),'_EndCoarse'],'-dpng', '-r300')
%             end
% %             figure(20 + iMice); 
% %             hold on; 
% %             switch iS
% %                 case 1
% %             plot(centers, cumsum(prob), 'r-', 'lineWidth', 1.5);
% %             probPerC = prob;
% %                 case 2
% %             plot(centers, cumsum(prob), 'b-','lineWidth', 1.5);
% %             probEndC = prob;
% %             [hc pc kc] = kstest2(probPerC, probEndC)          
% %             legend('Periosteum', 'Endosteum');
% %             set(gcf, 'color', [1,1,1]);
% %             grid on
% %             xlabel('Geometry difference (\mu m)');
% %             saveFig = ['rpd/',thisBone.Mice, '_101', faceName{iS}(1:3)]
% % %             %%print(saveFig, '-dpdf', '-r600');
%             end
         end
            
% --- 3. 5. 2 Fine Scale
        dtcplx1 = decompF;  
        dtcplx1.cfs = cfs;
        dtcplx1.cfs{Depth + 1} = zeros(size(dtcplx1.cfs{Depth + 1}));
        Y1 = idddtree2(dtcplx1); % Inverse dual-tree and double-density 2-D wavelet transform
        Y1(1:padSize-1, :) = [];    Y1(end-padSize: end, :) = [];
        Y1(:,1: cirSize-1) = [];      Y1(:, end-cirSize:end) = [];
        F_fine{iMice}{iS, iW} = Y1;
        ACT_WildMremodel(iS, iW, iMice) =1 - sum(sum(abs(Y1) < 6))/numel(Y1);
        activeF(iS, iW, iMice) = sum(reshape((abs(Y1) < 5).* abs(Y1), 1,[]));   
%       Y1(abs(Y1) < 10) = 0;
        if figSign
           figure(4);
            clf;
            hold on; 
            set(gcf, 'color',[1,1,1]);
            set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.2, 0.4])
            imagesc(thisBone.xlimits, thisBone.zlimits, Y1);
            xlim([-200 200]); ylim([0, 1800]); grid on; 
            ax = gca; ax.XTick = [-180 -90  0 90 180]; 
           % xticks([-180 -90  0 90 180]);
            set(gca,'Ydir', 'normal');
            colormap(RdBu);
            caxis([-40,40]);
            set(0, 'DefaultAxesFontSize', 12);
            xlabel('Angle (\circ)','fontsize',12); ylabel('Z','fontsize',12);
%             title({['Fine change at ', faceName{iS}], ...
%                [thisBone.Mice, 'W0', num2str(iW)]}, 'fontsize', 14);
            c = colorbar;  ax = gca;   
            axpos = ax.Position;  c.Position(3) = 0.6 * c.Position(3);  ax.Position = axpos;
            grid on; 
            drawnow;
            saveFig = [dataType, cropped,'/', thisBone.Mice, 'W0', num2str(iW), '_FineL', faceName{iS}(1:3)]
            figure(4)
            print(saveFig, '-dpng', '-r300')
        end         
        % 
        Y1(isnan(Y1)) = 0;
        Y1ave = []; Y1ave = mean(Y1, 2); Y1std = std(Y1,0, 2);
        if figSign == 0
            figure(200 + iMice);
            set(gcf, 'Units', 'normalized', 'position', [0.05, 0.2, 0.9, 0.22])
            subplot(1, size(WEEKS,2),iW-1)
            counts = []; centers = [];
            [counts, centers] = hist(reshape(Y1, 1, []),[-30:5:30]);
            prob = []; prob = counts./sum(counts);
            bar(centers, prob,'barwidth', 1)
            hold on; 
            set(gcf, 'color',[1,1,1]);
            title(['W0', num2str(iW)], 'fontsize',12);
            grid on; 
            xlim([-35,35]);
%             ylim([0,0.5])
            ax = gca; ax.XTick = [-30:10:30];
            xlabel('Geometry change (\mum)', 'fontsize',12)
            drawnow;
%             if iW == WEEKS(end)
%             print(['wild_Cropped/HistM', num2str(iMice),'_EndFine'],'-dpng', '-r300')
%             end
% %             figure(40 + iMice); 
% %             hold on; 
% %             switch iS
% %                 case 1
% %             plot(centers, cumsum(prob), 'r-', 'lineWidth', 1.5);
% %             probPerF = prob;
% %                 case 2
% %             plot(centers, cumsum(prob), 'b-','lineWidth', 1.5);
% %             probEndF = prob;
% %             saveFig = ['rpd/',thisBone.Mice, '_111', faceName{iS}(1:3)]
% % %             %%print(saveFig, '-dpdf', '-r600');
% % %             [hf pf kf] = kstest2(probPerF, probEndF)
% %             end
        end
%         
        if figSign
            figure(6);
            clf;
            hold on; 
            set(gcf, 'color',[1,1,1]);
            set(gcf, 'Units', 'normalized', 'position', [0.2, 0.2, 0.2, 0.4])
            imagesc(thisBone.xlimits, thisBone.zlimits, X0-Y0-Y1);
            xlim([-200, 200]); ylim([0, 1800]); grid on; 
            ax = gca; ax.XTick = [-180 -90  0 90 180];
%             xticks([-180 -90  0 90 180]);
            set(gca,'Ydir', 'normal');
            colormap(RdBu);
            caxis([-10,10]);
            set(0, 'DefaultAxesFontSize', 12);
            xlabel('Angle (\circ)','fontsize',12); ylabel('Z','fontsize',12);
            title({['Noise at ', faceName{iS}], ...
               [thisBone.Mice, 'W0', num2str(iW)]}, 'fontsize', 14);
               c = colorbar;  ax = gca;   
            axpos = ax.Position;  c.Position(3) = 0.6 * c.Position(3);  ax.Position = axpos;
            grid on; drawnow;
            saveFig = [thisBone.Mice, 'W0', num2str(iW), '_NoiseL', faceName{iS}(1:3) ]
%           print(saveFig, '-dpng', '-r300')
        end
    end
end
end 
 NMouse = 5; Weeks = [0,2; 0,3; 0,4;0,5; 0,6;0,7; 0,8];  
 save AnalysisWildF  F_coarse F_fine NMouse Weeks cfs_cplx  ACT_WildMremodel ACT_WildMremodel;
end


