    
%% -- plot bone surface with geometry change --
%  [] = bonePlot(iso, Fmap)
%  [] = bonePlot(iso, Fmap, caxisRange)
function [] = bonePlot(iso, Fmap, CAX)
       switch nargin
           case 2
               CAX = [-60,60];
           case 3
               CAX = CAX;
       end        
        addpath('functions/cbrewer');
        RdYlBu= flipud(cbrewer('div', 'RdYlBu', 256)); 
        RdBu= flipud(cbrewer('div', 'RdBu', 256));
%         iso = thisIso; 
%         Fmap = thisBone.UVF(:,3);
%         Fmap = F_coarse; 
        figure; 
%         set(gcf, 'Units', 'normalized', 'Position', [0.2, 0.2, 0.2, 0.4])
        set(gcf, 'Units', 'normalized', 'Position', [0.2, 0.1, 0.2, 0.6])
        patch(iso ,'FaceVertexCData', Fmap,'FaceColor','flat','EdgeColor','none')
%         view(3)
        view(125,20)
        axis equal;
        grid on;
        set(gcf, 'color', [1,1,1])
        colorbar;
        c = colorbar; 
        c.Position = [0.75, 0.25, 0.04, 0.5];
        c.FontSize = 18; 
        caxis(CAX);
        zlim([0, 1800])
        lighting gouraud;
        camlight('headlight', 'infinite') 
        colormap(RdBu);
        set(0,'defaultAxesFontSize',16);
%         xlabel('x','fontSize', 18)
%         ylabel('y', 'fontSize', 18)
%         zlabel('z','fontSize', 18)
end

