function [I_per, I_end, I_top, I_bot] = yzhSplitLSF(I,OPT)
% separte the surfaces of Tibia
% [I_per, I_end, I_top, I_bot] = yzhSplitLSF(I)
% I should be LSF or 3D image matrix
% OPT = 0, Give entire periosteum and endorsteum surface
% OPT = 1, Cut part of the top and bottom of the periosteum and endosteum
if nargin < 2
    OPT = 0; 
end

    Is = size(I);
    Tp2 = [];
    n = 1:Is(3);
    Tp1 = I(:,:,n)< 0;
    for k = 1:Is(3)
        Tp2(:,:,k) = imfill(Tp1(:,:,k),'holes'); 
    end
    
    if size(I,3)< 1000
        I_top = ['Sorry too small'];
        I_bot = ['Sorry'];
    else
        I_top = I(:,:,end-300:end); % TOP
        I_bot = I(:,:,1:200);         % BOTTOM
    end
    
if OPT == 0 
    I_per = (~Tp2).*(bwdist(Tp2)-0.5) - Tp2.*(bwdist(Tp2-1)-0.5);
    Temp = [];
    Temp = I.*Tp2;
    Temp = (Temp>0);
    I_end  = (~Temp).*(bwdist(Temp)-0.5) - Temp.*(bwdist(Temp-1)-0.5);

else
    Tp3 = Tp2(:,:,201:end-300);
    I_per = (~Tp3).*(bwdist(Tp3)-0.5) - Tp3.*(bwdist(Tp3-1)-0.5);
    Temp = [];
    Temp = I(:,:,201:end-300).*Tp3;
    Temp = (Temp>0);
    I_end  = (~Temp).*(bwdist(Temp)-0.5) - Temp.*(bwdist(Temp-1)-0.5);
end


