% yzhSeg3D_1.m 
% This is used to segment the tibia mask
% Include 1. Input  DICOM 
%         2. Read reference from dicom
%         3. Cut the febula 
%         4. Remove some of the other bones
%         5. Still need to go back to the Amira and ImageJ for corrections.
%         6. Tag = 1 for generating binary mask
%            Tag = 2 for combining the grey area to mask 
% If Tag = 2 need to be used, we need to perform Tag = 1 first. 

clear all; close all; clc;
addpath('functions/');

    
Tag = 1;
[fileNames, fileFolder] = uigetfile('*.dcm','Pick any DICOM image');
% fileFolder = 'D:\MULTISIM\DATA\Wild_CroppedTibia\Wild Mouse 1\WildM1W0N1163cropped\'
fileFolder = fullfile(fileFolder);
addpath(fileFolder);
d = dir(fullfile(fileFolder));
dirOutput=d(~ismember({d.name},{'.','..', '._Icon�?'}));
fileNames = {dirOutput.name}';
ReproducibilityData = strcmp('Reproducibility', fileNames{1}(1:length('Reproducibility')));
NFrames = numel(fileNames);

% ============================================== %
% Reading dicom files
% ============================================== %
%  ms.UseParallel = true;

for iF = 1:NFrames
    crossView = fileNames{iF};
    Y = [];
    Y = dicomread(crossView);
    Y= im2double(Y);
    Img(:,:,iF) =  Y;
    Att(iF) = dicominfo(crossView);
end

Img = smooth3(Img,'gaussian',3,0.65);
Thd = graythresh(Img)

ImgPatient = [Att(:).ImagePositionPatient]; % read the reference from dicom image 
revolution = 0.0104;
dP = ImgPatient(:,1)'./revolution
temp = [];    
% %  ------------ This is the reference I used for the wild mice ---- %
if ReproducibilityData
    display('This is the reproducibility data')
    padSize = round([dP(1,2)+170 , dP(1,1)+170, dP(1,3) + 50]); % keep all the image in the same reference
else
    display('This is the wild Mouse data') %wildCrop M3 -> +10 on second direction. 
    padSize = round([dP(1,2)+ 50, dP(1,1)+ 50, dP(1,3) + 50]); % keep all the image in the same reference
end

% Img = Img(14:end, :,:); 
% Img(:,1:padSize(2)*(-1),: ) = [];
% padSize = [0,padSize(2:end)];

Temp = padarray(Img,padSize,'pre');
Ibw = Temp - Thd; % Threshold change into 0 ;
Thd
% save WildM1W0_Ibw Ibw -v7.3
binaryMatrix = Ibw > 0;
clear  Img Ibw

% Connect filter
[Binary_islands, Num_islands] = bwlabeln(binaryMatrix,6);
[freq,number] = max(histc(Binary_islands(:),1:Num_islands));
binaryMatrix = double(Binary_islands == number);
clear Binary_islands freq number Num_islands
 
% 
for iF = 1: size(binaryMatrix,3)
    Ic = []; Ic = binaryMatrix(:,:,iF);
    Ic = imclose(Ic, strel('disk',4) );
%     
   if iF > 300 & iF < size(binaryMatrix,3) - 300 
       Ic = bwareaopen(Ic, 100);    
       L =[]; N = [];
       [L,N]= bwlabeln(Ic);
%         
      if  N < 4 & N > 0
       freq = []; number = [];
       [freq,number] = sort(histc(L(:),1:N));   
       Ic(L ~= number(end) ) = 0;
      end
   end
     binaryMask(:,:,iF) = Ic; %imdilate(Ic, SE);
 end
    [Binary_islands, Num_islands] = bwlabeln(binaryMask,6);
    [freq,number] = max(histc(Binary_islands(:),1:Num_islands));
    binaryMask= double(Binary_islands == number);
    
    fileFolder
%           
% writing mask images
    clearvars -except binaryMask fileNames fileFolder ReproducibilityData iii;
    folderIndex = find(fileFolder == '/');
    if isempty(folderIndex)
        folderIndex = find(fileFolder == '\');
    end
    if ReproducibilityData
       display('*** This is the reproducibility data ***')
       newFolder = [fileFolder(1:folderIndex(end-2)), fileNames{1}(1:16), '_Mask/', fileNames{1}(1:21), '_Mask/'];
    else
    newFolder = [fileFolder(1:folderIndex(end-2)), fileNames{1}(1:6), '_Mask\', fileNames{1}(1:8), '_Mask\']
    end
    mkdir(newFolder);
    for i =1:size(binaryMask,3)
       file_number = num2str(i,'%04d'); 
       %xyz = uint16(Binary_Matrix(:,:,i));
       xyz = (binaryMask(:,:,i));
%        imwrite(xyz, ['M5', '_',file_number, '.tif'], 'tiff')   ;   
       imwrite(xyz, strcat(newFolder, fileNames{1}(1:21), '_',file_number, '.tif'), 'tiff')      
    end
